"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _multipleChoiceList = _interopRequireDefault(require("./multiple-choice-list"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _formGroup = _interopRequireDefault(require("../form-group/form-group"));

var _Checkbox = require("@patternfly/react-core/dist/js/components/Checkbox/Checkbox.js");

var _isRequired = _interopRequireDefault(require("../is-required/is-required"));

var SingleCheckbox = function SingleCheckbox(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      label = _useFieldApi.label,
      isRequired = _useFieldApi.isRequired,
      helperText = _useFieldApi.helperText,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      description = _useFieldApi.description,
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      id = _useFieldApi.id,
      FormGroupProps = _useFieldApi.FormGroupProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["label", "isRequired", "helperText", "meta", "validateOnMount", "description", "input", "isReadOnly", "isDisabled", "id", "FormGroupProps"]);

  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    isRequired: isRequired,
    helperText: helperText,
    meta: meta,
    validateOnMount: validateOnMount,
    description: description,
    hideLabel: true,
    id: id || input.name,
    FormGroupProps: FormGroupProps
  }, /*#__PURE__*/_react["default"].createElement(_Checkbox.Checkbox, (0, _extends2["default"])({
    isChecked: input.checked
  }, input, {
    id: id || input.name,
    label: isRequired ? /*#__PURE__*/_react["default"].createElement(_isRequired["default"], null, label) : label,
    "aria-label": rest.name
  }, rest, {
    isDisabled: isDisabled || isReadOnly
  })));
};

SingleCheckbox.propTypes = {
  label: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  isDisabled: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  FormGroupProps: _propTypes["default"].object
};

var Checkbox = function Checkbox(_ref) {
  var options = _ref.options,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["options"]);
  return options ? /*#__PURE__*/_react["default"].createElement(_multipleChoiceList["default"], (0, _extends2["default"])({
    options: options
  }, props)) : /*#__PURE__*/_react["default"].createElement(SingleCheckbox, props);
};

Checkbox.propTypes = {
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].node,
    value: _propTypes["default"].any
  }))
};
var _default = Checkbox;
exports["default"] = _default;