"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _DualListSelector = require("@patternfly/react-core/dist/js/components/DualListSelector/DualListSelector.js");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _dualListTreeSelect = _interopRequireDefault(require("../dual-list-tree-select/dual-list-tree-select"));

var _formGroup = _interopRequireDefault(require("../form-group"));

var _dualListContext = _interopRequireDefault(require("../dual-list-context"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var DualList = function DualList(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
    FieldProps: {
      isEqual: function isEqual(current, initial) {
        return (0, _isEqual2["default"])((0, _toConsumableArray2["default"])(current || []).sort(), (0, _toConsumableArray2["default"])(initial || []).sort());
      }
    }
  })),
      label = _useFieldApi.label,
      isRequired = _useFieldApi.isRequired,
      helperText = _useFieldApi.helperText,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      description = _useFieldApi.description,
      hideLabel = _useFieldApi.hideLabel,
      id = _useFieldApi.id,
      input = _useFieldApi.input,
      FormGroupProps = _useFieldApi.FormGroupProps,
      options = _useFieldApi.options,
      getValueFromNode = _useFieldApi.getValueFromNode,
      isSearchable = _useFieldApi.isSearchable,
      isSortable = _useFieldApi.isSortable,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["label", "isRequired", "helperText", "meta", "validateOnMount", "description", "hideLabel", "id", "input", "FormGroupProps", "options", "getValueFromNode", "isSearchable", "isSortable"]);

  var _useState = (0, _react.useState)(function () {
    return {
      left: isSortable && 'asc',
      right: isSortable && 'asc'
    };
  }),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      sortConfig = _useState2[0],
      setSortConfig = _useState2[1];

  var value = input.value || [];
  var leftOptions;
  var rightOptions;
  var onListChange;
  var filterOption;

  if (!getValueFromNode) {
    leftOptions = options.filter(function (option) {
      return (0, _typeof2["default"])(option) === 'object' ? !value.includes(option.value) : !value.includes(option);
    }).map(function (option) {
      return option.label || option;
    });
    rightOptions = options.filter(function (option) {
      return (0, _typeof2["default"])(option) === 'object' ? value.includes(option.value) : value.includes(option);
    }).map(function (option) {
      return option.label || option;
    });

    onListChange = function onListChange(_newLeft, newRight) {
      return input.onChange(newRight);
    };

    filterOption = function filterOption(option, input) {
      return option.value ? option.value.includes(input) : option.includes(input);
    };
  } else {
    leftOptions = options.filter(function (option) {
      return option.value ? !value.includes(option.value) : !value.includes(getValueFromNode(option));
    }).map(function (option) {
      return option.label || option;
    });
    rightOptions = options.filter(function (option) {
      return option.value ? value.includes(option.value) : value.includes(getValueFromNode(option));
    }).map(function (option) {
      return option.label || option;
    });

    onListChange = function onListChange(_newLeft, newRight) {
      return input.onChange(newRight === null || newRight === void 0 ? void 0 : newRight.map(getValueFromNode));
    };

    filterOption = function filterOption(option, input) {
      return option.value ? option.value.includes(input) : getValueFromNode(option).includes(input);
    };
  }

  if (isSortable) {
    var sort = function sort(direction, a, b) {
      return direction === 'asc' ? a.localeCompare(b) : b.localeCompare(a);
    };

    if (!getValueFromNode) {
      leftOptions = leftOptions.sort(function (a, b) {
        return sort(sortConfig.left, a.label || a, b.label || b);
      });
      rightOptions = rightOptions.sort(function (a, b) {
        return sort(sortConfig.right, a.label || a, b.label || b);
      });
    } else {
      leftOptions = leftOptions.sort(function (a, b) {
        return sort(sortConfig.left, getValueFromNode(a.label || a), getValueFromNode(b.label || b));
      });
      rightOptions = rightOptions.sort(function (a, b) {
        return sort(sortConfig.right, getValueFromNode(a.label || a), getValueFromNode(b.label || b));
      });
    }
  }

  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    label: label,
    isRequired: isRequired,
    helperText: helperText,
    meta: meta,
    validateOnMount: validateOnMount,
    description: description,
    hideLabel: hideLabel,
    id: id || input.name,
    FormGroupProps: FormGroupProps
  }, /*#__PURE__*/_react["default"].createElement(_dualListContext["default"].Provider, {
    value: {
      sortConfig: sortConfig,
      setSortConfig: setSortConfig
    }
  }, /*#__PURE__*/_react["default"].createElement(_DualListSelector.DualListSelector, (0, _extends2["default"])({
    availableOptions: leftOptions,
    chosenOptions: rightOptions,
    onListChange: onListChange,
    id: id || input.name,
    isSearchable: isSearchable
  }, getValueFromNode && {
    addAll: onListChange,
    addSelected: onListChange,
    filterOption: filterOption,
    removeAll: onListChange,
    removeSelected: onListChange
  }, rest))));
};

DualList.propTypes = {
  label: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  hideLabel: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  getValueFromNode: _propTypes["default"].func,
  isSearchable: _propTypes["default"].bool,
  isSortable: _propTypes["default"].bool
};

var DualListWrapper = function DualListWrapper(props) {
  return props.isTree ? /*#__PURE__*/_react["default"].createElement(_dualListTreeSelect["default"], props) : /*#__PURE__*/_react["default"].createElement(DualList, props);
};

DualListWrapper.propTypes = {
  isTree: _propTypes["default"].bool
};
var _default = DualListWrapper;
exports["default"] = _default;