"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.getValueFromSelected = exports.selectedOptions = exports.convertOptions = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _DualListSelector = require("@patternfly/react-core/dist/js/components/DualListSelector/DualListSelector.js");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _formGroup = _interopRequireDefault(require("../form-group"));

var _dualListContext = _interopRequireDefault(require("../dual-list-context"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var convertOptions = function convertOptions(options, sort) {
  if (Array.isArray(options)) {
    var result = options.map(function (option) {
      return convertOptions(option, sort);
    }).filter(Boolean);

    if (sort) {
      var sortFn = function sortFn(a, b) {
        return sort === 'asc' ? a.localeCompare(b) : b.localeCompare(a);
      };

      result = result.sort(function (a, b) {
        return sortFn(a.text || a.label, b.text || b.label);
      });
    }

    return result;
  }

  return _objectSpread(_objectSpread({
    text: options.label,
    id: options.value || options.key || options.label || options.text,
    isChecked: false
  }, options), options.children && {
    children: convertOptions(options.children, sort).filter(Boolean)
  });
};

exports.convertOptions = convertOptions;

var selectedOptions = function selectedOptions(options, value, selected) {
  if (Array.isArray(options)) {
    return options.map(function (option) {
      return selectedOptions(option, value, selected);
    }).filter(Boolean);
  }

  if (options.value) {
    if (selected ? value.includes(options.value) : !value.includes(options.value)) {
      return options;
    }
  }

  if (options.children) {
    var someSelected = selectedOptions(options.children, value, selected).filter(Boolean);

    if (someSelected.length) {
      return _objectSpread(_objectSpread({}, options), {}, {
        children: someSelected
      });
    }
  }
};

exports.selectedOptions = selectedOptions;

var getValueFromSelected = function getValueFromSelected(options) {
  var newValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  if (Array.isArray(options)) {
    options.map(function (option) {
      return getValueFromSelected(option, newValue);
    });
  }

  if (options.value) {
    newValue.push(options.value);
  }

  if (options.children) {
    getValueFromSelected(options.children, newValue);
  }

  return newValue;
};

exports.getValueFromSelected = getValueFromSelected;

var DualListTreeSelect = function DualListTreeSelect(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
    FieldProps: {
      isEqual: function isEqual(current, initial) {
        return (0, _isEqual2["default"])((0, _toConsumableArray2["default"])(current || []).sort(), (0, _toConsumableArray2["default"])(initial || []).sort());
      }
    }
  })),
      label = _useFieldApi.label,
      isRequired = _useFieldApi.isRequired,
      helperText = _useFieldApi.helperText,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      description = _useFieldApi.description,
      hideLabel = _useFieldApi.hideLabel,
      id = _useFieldApi.id,
      input = _useFieldApi.input,
      FormGroupProps = _useFieldApi.FormGroupProps,
      options = _useFieldApi.options,
      isSortable = _useFieldApi.isSortable,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["label", "isRequired", "helperText", "meta", "validateOnMount", "description", "hideLabel", "id", "input", "FormGroupProps", "options", "isSortable"]);

  var _useState = (0, _react.useState)(function () {
    return {
      left: isSortable && 'asc',
      right: isSortable && 'asc'
    };
  }),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      sortConfig = _useState2[0],
      setSortConfig = _useState2[1];

  var value = input.value || [];
  var leftOptions = selectedOptions(options, value, false);
  var rightOptions = selectedOptions(options, value, true);

  var onListChange = function onListChange(_newLeft, newRight) {
    return input.onChange(getValueFromSelected(newRight));
  };

  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    label: label,
    isRequired: isRequired,
    helperText: helperText,
    meta: meta,
    validateOnMount: validateOnMount,
    description: description,
    hideLabel: hideLabel,
    id: id || input.name,
    FormGroupProps: FormGroupProps
  }, /*#__PURE__*/_react["default"].createElement(_dualListContext["default"].Provider, {
    value: {
      sortConfig: sortConfig,
      setSortConfig: setSortConfig
    }
  }, /*#__PURE__*/_react["default"].createElement(_DualListSelector.DualListSelector, (0, _extends2["default"])({
    availableOptions: convertOptions(leftOptions, sortConfig.left),
    chosenOptions: convertOptions(rightOptions, sortConfig.right),
    onListChange: onListChange,
    id: id || input.name,
    isTree: true
  }, rest))));
};

DualListTreeSelect.propTypes = {
  label: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  hideLabel: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  isSearchable: _propTypes["default"].bool,
  isSortable: _propTypes["default"].bool
};
var _default = DualListTreeSelect;
exports["default"] = _default;