import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import FormTemplate from '@data-driven-forms/common/form-template';
import { Button as PF4Button } from "@patternfly/react-core/dist/esm/components/Button/Button.js";
import { ActionGroup } from "@patternfly/react-core/dist/esm/components/Form/ActionGroup.js";
import { Form } from "@patternfly/react-core/dist/esm/components/Form/Form.js";
import { TextContent } from "@patternfly/react-core/dist/esm/components/Text/TextContent.js";
import { Text } from "@patternfly/react-core/dist/esm/components/Text/Text.js";
import { TextVariants } from "@patternfly/react-core/dist/esm/components/Text/Text.js";
export var Button = function Button(_ref) {
  var label = _ref.label,
      bsStyle = _ref.bsStyle,
      children = _ref.children,
      disabled = _ref.disabled,
      buttonType = _ref.buttonType,
      props = _objectWithoutProperties(_ref, ["label", "bsStyle", "children", "disabled", "buttonType"]);

  return /*#__PURE__*/React.createElement(PF4Button, _extends({
    variant: buttonType === 'cancel' ? 'link' : bsStyle || 'secondary',
    isDisabled: disabled
  }, props), label, children);
};
Button.propTypes = {
  label: PropTypes.node.isRequired,
  bsStyle: PropTypes.string,
  disabled: PropTypes.bool,
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]),
  buttonType: PropTypes.string
};
export var ButtonGroup = function ButtonGroup(_ref2) {
  var children = _ref2.children,
      props = _objectWithoutProperties(_ref2, ["children"]);

  return /*#__PURE__*/React.createElement(ActionGroup, props, children);
};
ButtonGroup.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};
export var Title = function Title(_ref3) {
  var children = _ref3.children,
      props = _objectWithoutProperties(_ref3, ["children"]);

  return /*#__PURE__*/React.createElement(TextContent, null, /*#__PURE__*/React.createElement(Text, _extends({
    component: TextVariants.h1
  }, props), children));
};
Title.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};
export var Description = function Description(_ref4) {
  var children = _ref4.children,
      props = _objectWithoutProperties(_ref4, ["children"]);

  return /*#__PURE__*/React.createElement(TextContent, null, /*#__PURE__*/React.createElement(Text, _extends({
    component: TextVariants.p
  }, props), children));
};
Description.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};

var PF4FormTemplate = function PF4FormTemplate(props) {
  return /*#__PURE__*/React.createElement(FormTemplate, _extends({
    FormWrapper: Form,
    Button: Button,
    ButtonGroup: ButtonGroup,
    Title: Title,
    Description: Description
  }, props));
};

export default PF4FormTemplate;