import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import { TextContent } from "@patternfly/react-core/dist/esm/components/Text/TextContent.js";
import { Text } from "@patternfly/react-core/dist/esm/components/Text/Text.js";
import validTextFields from '@data-driven-forms/common/utils/valid-text-fields';

var PlainText = function PlainText(_ref) {
  var component = _ref.component,
      label = _ref.label,
      name = _ref.name,
      variant = _ref.variant,
      TextContentProps = _ref.TextContentProps,
      rest = _objectWithoutProperties(_ref, ["component", "label", "name", "variant", "TextContentProps"]);

  return /*#__PURE__*/React.createElement(TextContent, TextContentProps, typeof label === 'string' ? label.split('\n').map(function (paragraph, index) {
    return /*#__PURE__*/React.createElement(Text, _extends({
      component: variant
    }, rest, {
      key: "".concat(name, "-").concat(index)
    }), paragraph);
  }) : label);
};

PlainText.propTypes = {
  variant: PropTypes.oneOf(validTextFields),
  label: PropTypes.node.isRequired,
  name: PropTypes.string.isRequired,
  TextContentProps: PropTypes.object,
  component: PropTypes.string
};
PlainText.defaultProps = {
  variant: 'p'
};
export default PlainText;