import React from 'react';
import PropTypes from 'prop-types';
import TimesCircleIcon from "@patternfly/react-icons/dist/esm/icons/times-circle-icon";
import './clear-indicator.css';

var ClearIndicator = function ClearIndicator(_ref) {
  var clearSelection = _ref.clearSelection;
  return /*#__PURE__*/React.createElement("button", {
    onClick: function onClick(event) {
      clearSelection();
      event.stopPropagation();
    },
    className: "pf-c-button pf-m-plain pf-c-select__toggle-clear pf-u-p-0",
    type: "button",
    "aria-label": "Clear all"
  }, /*#__PURE__*/React.createElement(TimesCircleIcon, null));
};

ClearIndicator.propTypes = {
  clearSelection: PropTypes.func.isRequired
};
export default ClearIndicator;