import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import CheckIcon from "@patternfly/react-icons/dist/esm/icons/check-icon";

var Option = function Option(_ref) {
  var item = _ref.item,
      isActive = _ref.isActive,
      isSelected = _ref.isSelected,
      props = _objectWithoutProperties(_ref, ["item", "isActive", "isSelected"]);

  return /*#__PURE__*/React.createElement("li", null, /*#__PURE__*/React.createElement("button", _extends({}, props, {
    disabled: item.isDisabled || item.disabled,
    type: "button",
    className: "pf-c-select__menu-item".concat(isSelected ? ' pf-m-selected' : '').concat(isActive ? ' pf-m-focus' : '').concat(item.isDisabled || item.disabled ? ' pf-m-disabled' : '')
  }), item.label, isSelected && /*#__PURE__*/React.createElement("span", {
    className: "pf-c-select__menu-item-icon"
  }, /*#__PURE__*/React.createElement(CheckIcon, null))));
};

Option.propTypes = {
  item: PropTypes.shape({
    label: PropTypes.node,
    isDisabled: PropTypes.bool,
    disabled: PropTypes.bool
  }).isRequired,
  isActive: PropTypes.bool,
  isSelected: PropTypes.bool,
  onClick: PropTypes.func.isRequired
};
export default Option;