import React, { Fragment } from 'react';
import PropTypes from 'prop-types';
import Input from './input';

var ValueContainer = function ValueContainer(_ref) {
  var value = _ref.value,
      isMulti = _ref.isMulti,
      placeholder = _ref.placeholder,
      getInputProps = _ref.getInputProps,
      isSearchable = _ref.isSearchable,
      inputRef = _ref.inputRef;

  if (isMulti && isSearchable) {
    return /*#__PURE__*/React.createElement(Fragment, null, value, /*#__PURE__*/React.createElement(Input, {
      placeholder: placeholder,
      inputRef: inputRef,
      getInputProps: getInputProps
    }));
  }

  if (!isMulti && isSearchable) {
    return /*#__PURE__*/React.createElement(Input, {
      placeholder: placeholder,
      inputRef: inputRef,
      getInputProps: getInputProps,
      value: value
    });
  }

  return /*#__PURE__*/React.createElement("span", {
    className: "pf-c-select__toggle-text"
  }, value || placeholder);
};

ValueContainer.propTypes = {
  value: PropTypes.node,
  placeholder: PropTypes.node,
  isMulti: PropTypes.bool,
  getInputProps: PropTypes.func.isRequired,
  isSearchable: PropTypes.bool,
  inputRef: PropTypes.object
};
export default ValueContainer;