"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFormApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _fieldArray = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/field-array"));

var _Bullseye = require("@patternfly/react-core/dist/js/layouts/Bullseye/Bullseye.js");

var _FormHelperText = require("@patternfly/react-core/dist/js/components/Form/FormHelperText.js");

var _Grid = require("@patternfly/react-core/dist/js/layouts/Grid/Grid.js");

var _GridItem = require("@patternfly/react-core/dist/js/layouts/Grid/GridItem.js");

var _addCircleOIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/add-circle-o-icon"));

var _closeIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/close-icon"));

require("./final-form-array.css");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var ArrayItem = (0, _react.memo)(function (_ref) {
  var fields = _ref.fields,
      fieldIndex = _ref.fieldIndex,
      name = _ref.name,
      remove = _ref.remove,
      length = _ref.length,
      minItems = _ref.minItems;

  var _useFormApi = (0, _useFormApi2["default"])(),
      renderForm = _useFormApi.renderForm;

  var widths = {
    label: fields[0].label ? 5 : 0,
    field: fields[0].label ? 7 : 12
  };
  var editedFields = fields.map(function (field, index) {
    var computedName = field.name ? "".concat(name, ".").concat(field.name) : name;
    return _objectSpread(_objectSpread({}, field), {}, {
      name: computedName,
      key: "".concat(name, "-").concat(index),
      hideLabel: true
    });
  });
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Grid.Grid, null, /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    sm: 11
  }, /*#__PURE__*/_react["default"].createElement("hr", {
    className: "ddf-final-form-hr"
  }))), /*#__PURE__*/_react["default"].createElement(_Grid.Grid, null, /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    sm: 11
  }, editedFields.map(function (field, index) {
    return /*#__PURE__*/_react["default"].createElement(_Grid.Grid, {
      key: "".concat(field.label, "-").concat(index),
      className: "ddf-final-form-array-grid"
    }, widths.label > 0 && /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
      sm: widths.label,
      key: "".concat(field.label, "-").concat(index)
    }, /*#__PURE__*/_react["default"].createElement("label", {
      htmlFor: field.name
    }, field.label, field.isRequired && /*#__PURE__*/_react["default"].createElement("span", {
      className: "pf-c-form__label-required"
    }, "*"))), /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
      sm: widths.field
    }, renderForm([field])));
  })), /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    sm: 1
  }, length > minItems && /*#__PURE__*/_react["default"].createElement(_Bullseye.Bullseye, null, /*#__PURE__*/_react["default"].createElement(_closeIcon["default"], {
    onClick: function onClick() {
      return remove(fieldIndex);
    },
    className: "ddf-final-form-group-remove-icon"
  })), length <= minItems && /*#__PURE__*/_react["default"].createElement(_Bullseye.Bullseye, null, /*#__PURE__*/_react["default"].createElement(_closeIcon["default"], {
    className: "ddf-final-form-group-remove-icon disabled"
  })))));
}, function (_ref2, _ref3) {
  var _prevRemove = _ref2.remove,
      prev = (0, _objectWithoutProperties2["default"])(_ref2, ["remove"]);
  var _nextRemove = _ref3.remove,
      next = (0, _objectWithoutProperties2["default"])(_ref3, ["remove"]);
  return (0, _isEqual["default"])(prev, next);
});
ArrayItem.propTypes = {
  name: _propTypes["default"].string,
  fieldIndex: _propTypes["default"].number.isRequired,
  fields: _propTypes["default"].arrayOf(_propTypes["default"].object),
  remove: _propTypes["default"].func.isRequired,
  length: _propTypes["default"].number,
  minItems: _propTypes["default"].number
};

var DynamicArray = function DynamicArray(_ref4) {
  var props = (0, _extends2["default"])({}, _ref4);

  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      arrayValidator = _useFieldApi.arrayValidator,
      label = _useFieldApi.label,
      description = _useFieldApi.description,
      formFields = _useFieldApi.fields,
      defaultItem = _useFieldApi.defaultItem,
      meta = _useFieldApi.meta,
      minItems = _useFieldApi.minItems,
      maxItems = _useFieldApi.maxItems,
      noItemsMessage = _useFieldApi.noItemsMessage,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["arrayValidator", "label", "description", "fields", "defaultItem", "meta", "minItems", "maxItems", "noItemsMessage"]);

  var dirty = meta.dirty,
      submitFailed = meta.submitFailed,
      error = meta.error,
      submitError = meta.submitError;
  var isError = (dirty || submitFailed) && (error || submitError) && (typeof error === 'string' || typeof submitError === 'string');
  return /*#__PURE__*/_react["default"].createElement(_fieldArray["default"], {
    key: rest.input.name,
    name: rest.input.name,
    validate: arrayValidator
  }, function (_ref5) {
    var _ref5$fields = _ref5.fields,
        map = _ref5$fields.map,
        _ref5$fields$value = _ref5$fields.value,
        value = _ref5$fields$value === void 0 ? [] : _ref5$fields$value,
        push = _ref5$fields.push,
        remove = _ref5$fields.remove;
    return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, label && /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
      sm: 12
    }, label), description && /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
      sm: 12
    }, description), value.length <= 0 && /*#__PURE__*/_react["default"].createElement(_Bullseye.Bullseye, null, /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
      sm: 12
    }, noItemsMessage)), map(function (name, index) {
      return /*#__PURE__*/_react["default"].createElement(ArrayItem, {
        key: "".concat(name, "-").concat(index),
        fields: formFields,
        name: name,
        fieldIndex: index,
        remove: remove,
        length: value.length,
        minItems: minItems
      });
    }), /*#__PURE__*/_react["default"].createElement(_Grid.Grid, null, /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
      sm: 11
    }, isError && /*#__PURE__*/_react["default"].createElement(_FormHelperText.FormHelperText, {
      isHidden: false,
      isError: true
    }, error || submitError)), /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
      sm: 1,
      className: "final-form-array-add-container"
    }, value.length < maxItems && /*#__PURE__*/_react["default"].createElement(_Bullseye.Bullseye, null, /*#__PURE__*/_react["default"].createElement(_addCircleOIcon["default"], {
      onClick: function onClick() {
        return push(defaultItem);
      },
      className: "ddf-final-form-group-add-icon"
    })), value.length >= maxItems && /*#__PURE__*/_react["default"].createElement(_Bullseye.Bullseye, null, /*#__PURE__*/_react["default"].createElement(_addCircleOIcon["default"], {
      className: "ddf-final-form-group-add-icon disabled"
    })))));
  });
};

DynamicArray.propTypes = {
  label: _propTypes["default"].node,
  description: _propTypes["default"].node,
  fields: _propTypes["default"].arrayOf(_propTypes["default"].object).isRequired,
  defaultItem: _propTypes["default"].any,
  minItems: _propTypes["default"].number,
  maxItems: _propTypes["default"].number,
  noItemsMessage: _propTypes["default"].node
};
DynamicArray.defaultProps = {
  maxItems: Infinity,
  minItems: 0,
  noItemsMessage: 'No items added'
};
var _default = DynamicArray;
exports["default"] = _default;