"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _FormGroup = require("@patternfly/react-core/dist/js/components/Form/FormGroup.js");

var _TextContent = require("@patternfly/react-core/dist/js/components/Text/TextContent.js");

var _Text = require("@patternfly/react-core/dist/js/components/Text/Text.js");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _showError = _interopRequireDefault(require("../show-error/show-error"));

var FormGroup = function FormGroup(_ref) {
  var label = _ref.label,
      isRequired = _ref.isRequired,
      helperText = _ref.helperText,
      meta = _ref.meta,
      validateOnMount = _ref.validateOnMount,
      description = _ref.description,
      hideLabel = _ref.hideLabel,
      children = _ref.children,
      id = _ref.id,
      FormGroupProps = _ref.FormGroupProps;
  return /*#__PURE__*/_react["default"].createElement(_FormGroup.FormGroup, (0, _extends2["default"])({
    isRequired: isRequired,
    label: !hideLabel && label,
    fieldId: id,
    helperText: meta.touched && meta.warning || helperText,
    helperTextInvalid: meta.error || meta.submitError
  }, (0, _showError["default"])(meta, validateOnMount), FormGroupProps), description && /*#__PURE__*/_react["default"].createElement(_TextContent.TextContent, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    component: "small"
  }, description)), children);
};

FormGroup.propTypes = {
  label: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  meta: _propTypes["default"].object.isRequired,
  description: _propTypes["default"].node,
  hideLabel: _propTypes["default"].bool,
  validateOnMount: _propTypes["default"].bool,
  id: _propTypes["default"].string.isRequired,
  children: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].arrayOf(_propTypes["default"].element)]).isRequired,
  FormGroupProps: _propTypes["default"].object
};
var _default = FormGroup;
exports["default"] = _default;