"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Description = exports.Title = exports.ButtonGroup = exports.Button = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formTemplate = _interopRequireDefault(require("@data-driven-forms/common/form-template"));

var _Button = require("@patternfly/react-core/dist/js/components/Button/Button.js");

var _ActionGroup = require("@patternfly/react-core/dist/js/components/Form/ActionGroup.js");

var _Form = require("@patternfly/react-core/dist/js/components/Form/Form.js");

var _TextContent = require("@patternfly/react-core/dist/js/components/Text/TextContent.js");

var _Text = require("@patternfly/react-core/dist/js/components/Text/Text.js");

var Button = function Button(_ref) {
  var label = _ref.label,
      bsStyle = _ref.bsStyle,
      children = _ref.children,
      disabled = _ref.disabled,
      buttonType = _ref.buttonType,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["label", "bsStyle", "children", "disabled", "buttonType"]);
  return /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
    variant: buttonType === 'cancel' ? 'link' : bsStyle || 'secondary',
    isDisabled: disabled
  }, props), label, children);
};

exports.Button = Button;
Button.propTypes = {
  label: _propTypes["default"].node.isRequired,
  bsStyle: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node]),
  buttonType: _propTypes["default"].string
};

var ButtonGroup = function ButtonGroup(_ref2) {
  var children = _ref2.children,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["children"]);
  return /*#__PURE__*/_react["default"].createElement(_ActionGroup.ActionGroup, props, children);
};

exports.ButtonGroup = ButtonGroup;
ButtonGroup.propTypes = {
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node])
};

var Title = function Title(_ref3) {
  var children = _ref3.children,
      props = (0, _objectWithoutProperties2["default"])(_ref3, ["children"]);
  return /*#__PURE__*/_react["default"].createElement(_TextContent.TextContent, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, (0, _extends2["default"])({
    component: _Text.TextVariants.h1
  }, props), children));
};

exports.Title = Title;
Title.propTypes = {
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node])
};

var Description = function Description(_ref4) {
  var children = _ref4.children,
      props = (0, _objectWithoutProperties2["default"])(_ref4, ["children"]);
  return /*#__PURE__*/_react["default"].createElement(_TextContent.TextContent, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, (0, _extends2["default"])({
    component: _Text.TextVariants.p
  }, props), children));
};

exports.Description = Description;
Description.propTypes = {
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node])
};

var PF4FormTemplate = function PF4FormTemplate(props) {
  return /*#__PURE__*/_react["default"].createElement(_formTemplate["default"], (0, _extends2["default"])({
    FormWrapper: _Form.Form,
    Button: Button,
    ButtonGroup: ButtonGroup,
    Title: Title,
    Description: Description
  }, props));
};

var _default = PF4FormTemplate;
exports["default"] = _default;