"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFieldApi3 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _Radio = require("@patternfly/react-core/dist/js/components/Radio/Radio.js");

var _formGroup = _interopRequireDefault(require("../form-group/form-group"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var RadioOption = function RadioOption(_ref) {
  var name = _ref.name,
      _ref$option = _ref.option,
      value = _ref$option.value,
      label = _ref$option.label,
      restOption = (0, _objectWithoutProperties2["default"])(_ref$option, ["value", "label"]),
      isDisabled = _ref.isDisabled,
      isReadOnly = _ref.isReadOnly;

  var _useFieldApi = (0, _useFieldApi3["default"])({
    name: name,
    value: value
  }),
      input = _useFieldApi.input;

  return /*#__PURE__*/_react["default"].createElement(_Radio.Radio, (0, _extends2["default"])({
    key: "".concat(name, "-").concat(value)
  }, input, {
    isChecked: input.value === value,
    value: value,
    onChange: function onChange() {
      return input.onChange(value);
    },
    label: label,
    id: "".concat(name, "-").concat(value),
    "aria-label": label,
    isDisabled: isDisabled || isReadOnly
  }, restOption));
};

RadioOption.propTypes = {
  name: _propTypes["default"].string.isRequired,
  option: _propTypes["default"].shape({
    label: _propTypes["default"].node.isRequired,
    value: _propTypes["default"].any.isRequired
  }).isRequired,
  isDisabled: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  radioGroupValue: _propTypes["default"].any
};

var Radio = function Radio(_ref2) {
  var name = _ref2.name,
      options = _ref2.options,
      type = _ref2.type,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["name", "options", "type"]);

  /**
   * You cannot assign type radio to PF4 radio buttons input. It will break and will not set input value, only checked property
   * It has to be reqular input and we have change the radio value manully to the option value
   */
  var _useFieldApi2 = (0, _useFieldApi3["default"])(_objectSpread({
    name: name
  }, props)),
      label = _useFieldApi2.label,
      isRequired = _useFieldApi2.isRequired,
      helperText = _useFieldApi2.helperText,
      meta = _useFieldApi2.meta,
      validateOnMount = _useFieldApi2.validateOnMount,
      description = _useFieldApi2.description,
      hideLabel = _useFieldApi2.hideLabel,
      input = _useFieldApi2.input,
      isReadOnly = _useFieldApi2.isReadOnly,
      isDisabled = _useFieldApi2.isDisabled,
      id = _useFieldApi2.id,
      FormGroupProps = _useFieldApi2.FormGroupProps;

  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    label: label,
    isRequired: isRequired,
    helperText: helperText,
    meta: meta,
    validateOnMount: validateOnMount,
    description: description,
    hideLabel: hideLabel,
    id: id || input.name,
    FormGroupProps: FormGroupProps
  }, options.map(function (option) {
    return /*#__PURE__*/_react["default"].createElement(RadioOption, {
      key: option.value,
      name: name,
      option: option,
      isReadOnly: isReadOnly,
      isDisabled: isDisabled
    });
  }));
};

Radio.propTypes = {
  label: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  hideLabel: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  name: _propTypes["default"].string.isRequired,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].node,
    value: _propTypes["default"].any
  })).isRequired,
  type: _propTypes["default"].any,
  FormGroupProps: _propTypes["default"].object
};
var _default = Radio;
exports["default"] = _default;