"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./input.css");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var getInputString = function getInputString(filter, value) {
  if (typeof filter === 'string') {
    return filter;
  }

  if (typeof value === 'string') {
    return value;
  }

  if (Array.isArray(value) && typeof value[0] === 'string') {
    return value[0];
  }

  return '';
};

var Input = function Input(_ref) {
  var inputRef = _ref.inputRef,
      isSearchable = _ref.isSearchable,
      isDisabled = _ref.isDisabled,
      getInputProps = _ref.getInputProps,
      value = _ref.value,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["inputRef", "isSearchable", "isDisabled", "getInputProps", "value"]);
  var inputProps = getInputProps({
    disabled: isDisabled
  });
  var initialInputValue = getInputString(inputProps.value, value);
  return /*#__PURE__*/_react["default"].createElement("input", (0, _extends2["default"])({
    value: ""
  }, props, {
    className: "pf-c-form-control pf-c-select__toggle-typeahead",
    ref: inputRef
  }, _objectSpread(_objectSpread({}, inputProps), {}, {
    value: initialInputValue,
    onKeyDown: function onKeyDown(event) {
      event.stopPropagation();

      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      inputProps.onKeyDown.apply(inputProps, [event].concat(args));
    },
    onChange: inputProps.onChange || Function
  })));
};

Input.propTypes = {
  inputRef: _propTypes["default"].shape({
    current: _propTypes["default"].instanceOf(Element)
  }),
  isSearchable: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  getInputProps: _propTypes["default"].func.isRequired,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].string)])
};
var _default = Input;
exports["default"] = _default;