"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _select = _interopRequireDefault(require("@data-driven-forms/common/select"));

var _parseInternalValue = _interopRequireDefault(require("@data-driven-forms/common/select/parse-internal-value"));

var _downshift = _interopRequireDefault(require("downshift"));

var _caretDownIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/caret-down-icon"));

var _closeIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/close-icon"));

var _circleNotchIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/circle-notch-icon"));

require("./select-styles.css");

require("@patternfly/react-styles/css/components/Select/select.css");

require("@patternfly/react-styles/css/components/Chip/chip.css");

require("@patternfly/react-styles/css/components/ChipGroup/chip-group.css");

require("@patternfly/react-styles/css/components/Divider/divider.css");

var _menu = _interopRequireDefault(require("./menu"));

var _clearIndicator = _interopRequireDefault(require("./clear-indicator"));

var _valueContainer = _interopRequireDefault(require("./value-container"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _itemToString = function itemToString(value, isMulti, showMore, handleShowMore, handleChange) {
  if (!value) {
    return '';
  }

  if (Array.isArray(value)) {
    if (!value || value.length === 0) {
      return;
    }

    if (isMulti) {
      var visibleOptions = showMore ? value : value.slice(0, 3);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "pf-c-chip-group pf-u-ml-sm",
        onClick: function onClick(event) {
          return event.stopPropagation();
        }
      }, /*#__PURE__*/_react["default"].createElement("ul", {
        className: "pf-c-chip-group__list",
        "aria-label": "Chip group category"
      }, visibleOptions.map(function (item, index) {
        var label = (0, _typeof2["default"])(item) === 'object' ? item.label : item;
        return /*#__PURE__*/_react["default"].createElement("li", {
          className: "pf-c-chip-group__list-item",
          onClick: function onClick(event) {
            return event.stopPropagation();
          },
          key: item.key || item.value || item
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "pf-c-chip"
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "pf-c-chip__text",
          id: "pf-random-id-".concat(index, "-").concat(label)
        }, label), /*#__PURE__*/_react["default"].createElement("button", {
          onClick: function onClick() {
            return handleChange(item);
          },
          className: "pf-c-button pf-m-plain",
          type: "button"
        }, /*#__PURE__*/_react["default"].createElement(_closeIcon["default"], null))));
      }), value.length > 3 && /*#__PURE__*/_react["default"].createElement("li", {
        className: "pf-c-chip-group__list-item"
      }, /*#__PURE__*/_react["default"].createElement("button", {
        type: "button",
        onClick: handleShowMore,
        className: "pf-c-chip pf-m-overflow"
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "pf-c-chip__text"
      }, showMore ? 'Show less' : "".concat(value.length - 3, " more"))))));
    }

    return value.map(function (item) {
      return (0, _typeof2["default"])(item) === 'object' ? item.label : item;
    });
  }

  if ((0, _typeof2["default"])(value) === 'object') {
    return value.label;
  }

  return value;
}; // TODO fix the value of internal select not to be an array all the time. It forces the filter value to be an array and it crashes sometimes.


var filterOptions = function filterOptions(options) {
  var filterValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  return options.filter(function (_ref) {
    var label = _ref.label;
    var filter = Array.isArray(filterValue) && filterValue.length > 0 ? filterValue[0] : filterValue;
    return label.toLowerCase().includes(filter.toLowerCase());
  });
};

var getValue = function getValue(isMulti, option, value) {
  if (!isMulti || !option) {
    return option;
  }

  var isSelected = value.find(function (_ref2) {
    var value = _ref2.value;
    return value === option.value;
  });
  return isSelected ? value.filter(function (_ref3) {
    var value = _ref3.value;
    return value !== option.value;
  }) : [].concat((0, _toConsumableArray2["default"])(value), [option]);
};

var _stateReducer = function stateReducer(state, changes, isMulti) {
  switch (changes.type) {
    case _downshift["default"].stateChangeTypes.clickButton:
      return _objectSpread(_objectSpread(_objectSpread({}, state), changes), {}, {
        highlightedIndex: undefined,
        // reset the item focus to prevent initial scroll and portal menu warping
        inputValue: undefined
      });

    case _downshift["default"].stateChangeTypes.keyDownEnter:
    case _downshift["default"].stateChangeTypes.clickItem:
      return _objectSpread(_objectSpread({}, changes), {}, {
        isOpen: isMulti ? state.isOpen : !state.isOpen,
        highlightedIndex: state.highlightedIndex,
        inputValue: isMulti ? state.inputValue : changes.inputValue // prevent filter value change after option click

      });

    case _downshift["default"].stateChangeTypes.controlledPropUpdatedSelectedItem:
      return _objectSpread(_objectSpread({}, changes), {}, {
        inputValue: state.inputValue
      });

    case _downshift["default"].stateChangeTypes.mouseUp:
      if (typeof changes.inputValue === 'string') {
        return _objectSpread({}, changes);
      }

      if (Array.isArray(changes.inputValue) && typeof changes.inputValue[0] === 'string') {
        return _objectSpread(_objectSpread({}, changes), {}, {
          inputValue: changes.inputValue[0]
        });
      }

      if (state.isOpen === true && changes.isOpen === false && changes.inputValue) {
        return _objectSpread(_objectSpread(_objectSpread({}, state), changes), {}, {
          inputValue: ''
        });
      }

      return _objectSpread(_objectSpread({}, changes), {}, {
        inputValue: state.inputValue
      });

    default:
      return changes;
  }
};

var InternalSelect = function InternalSelect(_ref4) {
  var noResultsMessage = _ref4.noResultsMessage,
      noOptionsMessage = _ref4.noOptionsMessage,
      onChange = _ref4.onChange,
      options = _ref4.options,
      value = _ref4.value,
      simpleValue = _ref4.simpleValue,
      placeholder = _ref4.placeholder,
      isSearchable = _ref4.isSearchable,
      isDisabled = _ref4.isDisabled,
      isClearable = _ref4.isClearable,
      isMulti = _ref4.isMulti,
      isFetching = _ref4.isFetching,
      onInputChange = _ref4.onInputChange,
      loadingMessage = _ref4.loadingMessage,
      menuPortalTarget = _ref4.menuPortalTarget,
      menuIsPortal = _ref4.menuIsPortal,
      props = (0, _objectWithoutProperties2["default"])(_ref4, ["noResultsMessage", "noOptionsMessage", "onChange", "options", "value", "simpleValue", "placeholder", "isSearchable", "isDisabled", "isClearable", "isMulti", "isFetching", "onInputChange", "loadingMessage", "menuPortalTarget", "menuIsPortal"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      showMore = _useState2[0],
      setShowMore = _useState2[1];

  var inputRef = (0, _react.useRef)();
  var selectToggleRef = (0, _react.useRef)();
  var parsedValue = (0, _parseInternalValue["default"])(value);

  var handleShowMore = function handleShowMore() {
    return setShowMore(function (prev) {
      return !prev;
    });
  };

  var handleChange = function handleChange(option) {
    return onChange(getValue(isMulti, option, value));
  };

  return /*#__PURE__*/_react["default"].createElement(_downshift["default"], {
    id: props.id || props.name,
    onChange: handleChange,
    itemToString: function itemToString(value) {
      return _itemToString(value, isMulti, showMore, handleShowMore, handleChange);
    },
    selectedItem: value || '',
    stateReducer: function stateReducer(state, changes) {
      return _stateReducer(state, changes, isMulti);
    },
    onInputValueChange: function onInputValueChange(inputValue, _ref5) {
      var selectedItem = _ref5.selectedItem;

      /**
       * Prevent firing te load options callback when selecting value not filtering
       */
      if (onInputChange && typeof inputValue === 'string' && (selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.label) !== inputValue) {
        onInputChange(inputValue);
      }
    }
  }, function (_ref6) {
    var isOpen = _ref6.isOpen,
        inputValue = _ref6.inputValue,
        itemToString = _ref6.itemToString,
        selectedItem = _ref6.selectedItem,
        clearSelection = _ref6.clearSelection,
        getInputProps = _ref6.getInputProps,
        getToggleButtonProps = _ref6.getToggleButtonProps,
        getItemProps = _ref6.getItemProps,
        highlightedIndex = _ref6.highlightedIndex;
    var toggleButtonProps = getToggleButtonProps();
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "pf-c-select"
    }, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      ref: selectToggleRef,
      disabled: isDisabled,
      className: "pf-c-select__toggle".concat(isDisabled ? ' pf-m-disabled' : '').concat(isSearchable ? ' pf-m-typeahead' : '', " ddorg__pf4-component-mapper__select-toggle")
    }, toggleButtonProps), /*#__PURE__*/_react["default"].createElement("div", {
      className: "pf-c-select_toggle-wrapper ddorg__pf4-component-mapper__select-toggle-wrapper"
    }, /*#__PURE__*/_react["default"].createElement(_valueContainer["default"], {
      isMulti: isMulti,
      isSearchable: isSearchable,
      placeholder: placeholder,
      inputRef: inputRef,
      getInputProps: getInputProps,
      value: itemToString(selectedItem, isMulti, showMore, handleShowMore, handleChange)
    })), isClearable && parsedValue && /*#__PURE__*/_react["default"].createElement(_clearIndicator["default"], {
      clearSelection: clearSelection
    }), /*#__PURE__*/_react["default"].createElement("span", {
      className: "pf-c-select__toggle-arrow"
    }, isFetching ? /*#__PURE__*/_react["default"].createElement(_circleNotchIcon["default"], {
      className: "ddorg__pf4-component-mapper__select-loading-icon"
    }) : /*#__PURE__*/_react["default"].createElement(_caretDownIcon["default"], null))), isOpen && /*#__PURE__*/_react["default"].createElement(_menu["default"], {
      noResultsMessage: noResultsMessage,
      noOptionsMessage: noOptionsMessage,
      isFetching: isFetching,
      isDisabled: isDisabled,
      isSearchable: isSearchable,
      getInputProps: getInputProps,
      filterOptions: filterOptions,
      filterValue: inputValue,
      options: options,
      getItemProps: getItemProps,
      highlightedIndex: highlightedIndex,
      selectedItem: isMulti ? value : parsedValue,
      isMulti: isMulti,
      menuPortalTarget: menuPortalTarget,
      menuIsPortal: menuIsPortal,
      selectToggleRef: selectToggleRef
    }));
  });
};

InternalSelect.propTypes = {
  onChange: _propTypes["default"].func.isRequired,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].any,
    label: _propTypes["default"].any
  })).isRequired,
  value: _propTypes["default"].any,
  simpleValue: _propTypes["default"].bool,
  placeholder: _propTypes["default"].string,
  isSearchable: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  name: _propTypes["default"].string.isRequired,
  isDisabled: _propTypes["default"].bool,
  isClearable: _propTypes["default"].bool,
  noResultsMessage: _propTypes["default"].node,
  noOptionsMessage: _propTypes["default"].func,
  isMulti: _propTypes["default"].bool,
  isFetching: _propTypes["default"].bool,
  onInputChange: _propTypes["default"].func,
  loadingMessage: _propTypes["default"].node,
  menuPortalTarget: _propTypes["default"].any,
  menuIsPortal: _propTypes["default"].bool
};

var Select = function Select(_ref7) {
  var menuIsPortal = _ref7.menuIsPortal,
      props = (0, _objectWithoutProperties2["default"])(_ref7, ["menuIsPortal"]);
  var menuPortalTarget = menuIsPortal ? document.body : undefined;
  return /*#__PURE__*/_react["default"].createElement(_select["default"], (0, _extends2["default"])({
    SelectComponent: InternalSelect,
    menuPortalTarget: menuPortalTarget,
    menuIsPortal: menuIsPortal
  }, props));
};

Select.propTypes = {
  isSearchable: _propTypes["default"].bool,
  showMoreLabel: _propTypes["default"].node,
  showLessLabel: _propTypes["default"].node,
  simpleValue: _propTypes["default"].bool,
  value: _propTypes["default"].any,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].any,
    label: _propTypes["default"].any
  })),
  onChange: _propTypes["default"].func.isRequired,
  isMulti: _propTypes["default"].bool,
  loadOptions: _propTypes["default"].func,
  loadingMessage: _propTypes["default"].node,
  updatingMessage: _propTypes["default"].node,
  menuIsPortal: _propTypes["default"].bool,
  placeholder: _propTypes["default"].string,
  noResultsMessage: _propTypes["default"].node,
  noOptionsMessage: _propTypes["default"].node
};
Select.defaultProps = {
  showMoreLabel: 'more',
  showLessLabel: 'Show less',
  simpleValue: true,
  loadingMessage: 'Loading...',
  updatingMessage: 'Loading data...',
  options: [],
  menuIsPortal: false,
  placeholder: 'Choose...',
  isSearchable: false,
  isClearable: false,
  noResultsMessage: 'No results found',
  noOptionsMessage: 'No options'
};
var _default = Select;
exports["default"] = _default;