"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _input = _interopRequireDefault(require("./input"));

var ValueContainer = function ValueContainer(_ref) {
  var value = _ref.value,
      isMulti = _ref.isMulti,
      placeholder = _ref.placeholder,
      getInputProps = _ref.getInputProps,
      isSearchable = _ref.isSearchable,
      inputRef = _ref.inputRef;

  if (isMulti && isSearchable) {
    return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, value, /*#__PURE__*/_react["default"].createElement(_input["default"], {
      placeholder: placeholder,
      inputRef: inputRef,
      getInputProps: getInputProps
    }));
  }

  if (!isMulti && isSearchable) {
    return /*#__PURE__*/_react["default"].createElement(_input["default"], {
      placeholder: placeholder,
      inputRef: inputRef,
      getInputProps: getInputProps,
      value: value
    });
  }

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "pf-c-select__toggle-text"
  }, value || placeholder);
};

ValueContainer.propTypes = {
  value: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isMulti: _propTypes["default"].bool,
  getInputProps: _propTypes["default"].func.isRequired,
  isSearchable: _propTypes["default"].bool,
  inputRef: _propTypes["default"].object
};
var _default = ValueContainer;
exports["default"] = _default;