"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFormApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _Tab = require("@patternfly/react-core/dist/js/components/Tabs/Tab.js");

var _Tabs = require("@patternfly/react-core/dist/js/components/Tabs/Tabs.js");

var _TabTitleText = require("@patternfly/react-core/dist/js/components/Tabs/TabTitleText.js");

var FormTabs = function FormTabs(_ref) {
  var fields = _ref.fields,
      dataType = _ref.dataType,
      validate = _ref.validate,
      component = _ref.component,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["fields", "dataType", "validate", "component"]);
  var formOptions = (0, _useFormApi["default"])();

  var _useState = (0, _react.useState)(0),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      activeTabKey = _useState2[0],
      setActiveTabKey = _useState2[1];

  var handleTabClick = function handleTabClick(event, tabIndex) {
    event.preventDefault();
    setActiveTabKey(tabIndex);
  };

  var renderTabItems = function renderTabItems(fields) {
    return fields.map(function (_ref2, index) {
      var fields = _ref2.fields,
          title = _ref2.title,
          name = _ref2.name;
      return /*#__PURE__*/_react["default"].createElement(_Tab.Tab, {
        key: name,
        eventKey: index,
        title: typeof title === 'string' ? /*#__PURE__*/_react["default"].createElement(_TabTitleText.TabTitleText, null, title) : title
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "pf-c-form"
      }, formOptions.renderForm(fields, formOptions)));
    });
  };

  return /*#__PURE__*/_react["default"].createElement(_Tabs.Tabs, (0, _extends2["default"])({
    activeKey: activeTabKey,
    onSelect: handleTabClick
  }, rest), renderTabItems(fields, formOptions));
};

FormTabs.propTypes = {
  fields: _propTypes["default"].array.isRequired,
  dataType: _propTypes["default"].any,
  validate: _propTypes["default"].any,
  component: _propTypes["default"].any
};
var _default = FormTabs;
exports["default"] = _default;