"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = require("@patternfly/react-core/dist/js/components/Button/Button.js");

var _selectNext = _interopRequireDefault(require("@data-driven-forms/common/wizard/select-next"));

var _formSpy = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/form-spy"));

var NextButton = function NextButton(_ref) {
  var nextStep = _ref.nextStep,
      valid = _ref.valid,
      handleNext = _ref.handleNext,
      nextLabel = _ref.nextLabel,
      getState = _ref.getState,
      handleSubmit = _ref.handleSubmit,
      submitLabel = _ref.submitLabel;
  return /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    variant: "primary",
    type: "button",
    isDisabled: !valid || getState().validating,
    onClick: function onClick() {
      return nextStep ? handleNext((0, _selectNext["default"])(nextStep, getState)) : handleSubmit();
    }
  }, nextStep ? nextLabel : submitLabel);
};

NextButton.propTypes = {
  nextStep: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func, _propTypes["default"].object]),
  handleSubmit: _propTypes["default"].func.isRequired,
  submitLabel: _propTypes["default"].node.isRequired,
  valid: _propTypes["default"].bool,
  handleNext: _propTypes["default"].func.isRequired,
  nextLabel: _propTypes["default"].node.isRequired,
  getState: _propTypes["default"].func.isRequired
};

var WizardStepButtons = function WizardStepButtons(_ref2) {
  var Buttons = _ref2.buttons,
      disableBack = _ref2.disableBack,
      handlePrev = _ref2.handlePrev,
      nextStep = _ref2.nextStep,
      handleNext = _ref2.handleNext,
      buttonsClassName = _ref2.buttonsClassName,
      _ref2$buttonLabels = _ref2.buttonLabels,
      cancel = _ref2$buttonLabels.cancel,
      submit = _ref2$buttonLabels.submit,
      back = _ref2$buttonLabels.back,
      next = _ref2$buttonLabels.next,
      formOptions = _ref2.formOptions;
  return /*#__PURE__*/_react["default"].createElement("footer", {
    className: "pf-c-wizard__footer ".concat(buttonsClassName ? buttonsClassName : '')
  }, Buttons ? /*#__PURE__*/_react["default"].createElement(Buttons, {
    disableBack: disableBack,
    handlePrev: handlePrev,
    nextStep: nextStep,
    handleNext: handleNext,
    buttonsClassName: buttonsClassName,
    buttonLabels: {
      cancel: cancel,
      submit: submit,
      back: back,
      next: next
    },
    renderNextButton: function renderNextButton(args) {
      return /*#__PURE__*/_react["default"].createElement(NextButton, (0, _extends2["default"])({}, formOptions, {
        handleNext: handleNext,
        nextStep: nextStep,
        nextLabel: next,
        submitLabel: submit
      }, args));
    },
    selectNext: _selectNext["default"]
  }) : /*#__PURE__*/_react["default"].createElement(_formSpy["default"], null, function () {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(NextButton, (0, _extends2["default"])({}, formOptions, {
      handleNext: handleNext,
      nextStep: nextStep,
      nextLabel: next,
      submitLabel: submit
    })), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
      type: "button",
      variant: "secondary",
      isDisabled: disableBack,
      onClick: handlePrev
    }, back), /*#__PURE__*/_react["default"].createElement("div", {
      className: "pf-c-wizard__footer-cancel"
    }, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
      type: "button",
      variant: "link",
      onClick: formOptions.onCancel
    }, cancel)));
  }));
};

WizardStepButtons.propTypes = {
  disableBack: _propTypes["default"].bool,
  handlePrev: _propTypes["default"].func.isRequired,
  handleNext: _propTypes["default"].func.isRequired,
  nextStep: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].shape({
    when: _propTypes["default"].string.isRequired,
    stepMapper: _propTypes["default"].object.isRequired
  }), _propTypes["default"].func]),
  buttonLabels: _propTypes["default"].shape({
    submit: _propTypes["default"].node.isRequired,
    cancel: _propTypes["default"].node.isRequired,
    back: _propTypes["default"].node.isRequired,
    next: _propTypes["default"].node.isRequired
  }).isRequired,
  buttonsClassName: _propTypes["default"].string,
  buttons: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func]),
  formOptions: _propTypes["default"].shape({
    getState: _propTypes["default"].func.isRequired,
    onCancel: _propTypes["default"].func.isRequired
  })
};
var _default = WizardStepButtons;
exports["default"] = _default;