"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _WizardNavItem = require("@patternfly/react-core/dist/js/components/Wizard/WizardNavItem.js");

var _WizardNav = require("@patternfly/react-core/dist/js/components/Wizard/WizardNav.js");

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _get = _interopRequireDefault(require("lodash/get"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var memoValues = function memoValues(initialValue) {
  var valueCache = initialValue;
  return function (value) {
    if (!(0, _isEqual["default"])(value, valueCache)) {
      valueCache = value;
      return true;
    }

    return false;
  };
};

var WizardNavigationInternal = _react["default"].memo(function (_ref) {
  var navSchema = _ref.navSchema,
      activeStepIndex = _ref.activeStepIndex,
      maxStepIndex = _ref.maxStepIndex,
      jumpToStep = _ref.jumpToStep,
      valid = _ref.valid,
      validating = _ref.validating;
  return navSchema.filter(function (field) {
    return field.primary;
  }).map(function (step) {
    var substeps = step.substepOf && navSchema.filter(function (field) {
      return field.substepOf === step.substepOf;
    });
    var isValid = valid && !validating;
    return /*#__PURE__*/_react["default"].createElement(_WizardNavItem.WizardNavItem, {
      key: step.substepOf || step.name,
      content: step.substepOfTitle || step.title,
      isCurrent: substeps ? activeStepIndex >= step.index && activeStepIndex < step.index + substeps.length : activeStepIndex === step.index,
      isDisabled: isValid ? maxStepIndex < step.index : step.index > activeStepIndex,
      onNavItemClick: function onNavItemClick(ind) {
        return jumpToStep(ind, isValid);
      },
      step: step.index,
      type: "button"
    }, substeps && /*#__PURE__*/_react["default"].createElement(_WizardNav.WizardNav, {
      returnList: true
    }, substeps.map(function (substep) {
      return /*#__PURE__*/_react["default"].createElement(_WizardNavItem.WizardNavItem, {
        type: "button",
        key: substep.name,
        content: substep.title,
        isCurrent: activeStepIndex === substep.index,
        isDisabled: isValid ? maxStepIndex < substep.index : substep.index > activeStepIndex,
        onNavItemClick: function onNavItemClick(ind) {
          return jumpToStep(ind, isValid);
        },
        step: substep.index
      });
    })));
  });
}, _isEqual["default"]);

WizardNavigationInternal.propTypes = {
  activeStepIndex: _propTypes["default"].number.isRequired,
  maxStepIndex: _propTypes["default"].number.isRequired,
  jumpToStep: _propTypes["default"].func.isRequired,
  navSchema: _propTypes["default"].array.isRequired,
  valid: _propTypes["default"].bool.isRequired,
  validating: _propTypes["default"].bool.isRequired
};

var WizardNavigation = function WizardNavigation(_ref2) {
  var setPrevSteps = _ref2.setPrevSteps,
      crossroads = _ref2.crossroads,
      values = _ref2.values,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["setPrevSteps", "crossroads", "values"]);

  var _useState = (0, _react.useState)(function () {
    return memoValues(crossroads ? crossroads.reduce(function (acc, curr) {
      return _objectSpread(_objectSpread({}, acc), {}, (0, _defineProperty2["default"])({}, curr, (0, _get["default"])(values, curr)));
    }, {}) : {});
  }),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 1),
      memoValue = _useState2[0];

  (0, _react.useEffect)(function () {
    if (crossroads) {
      var modifiedRoad = crossroads.reduce(function (acc, curr) {
        return _objectSpread(_objectSpread({}, acc), {}, (0, _defineProperty2["default"])({}, curr, (0, _get["default"])(values, curr)));
      }, {});

      if (memoValue(modifiedRoad)) {
        setPrevSteps();
      }
    }
  });
  return /*#__PURE__*/_react["default"].createElement(WizardNavigationInternal, props);
};

WizardNavigation.propTypes = {
  setPrevSteps: _propTypes["default"].func.isRequired,
  values: _propTypes["default"].object.isRequired,
  crossroads: _propTypes["default"].arrayOf(_propTypes["default"].string)
};
var _default = WizardNavigation;
exports["default"] = _default;