"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RenderTitle = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Title = require("@patternfly/react-core/dist/js/components/Title/Title.js");

var _WizardBody = require("@patternfly/react-core/dist/js/components/Wizard/WizardBody.js");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _stepButtons = _interopRequireDefault(require("./step-buttons"));

var RenderTitle = function RenderTitle(_ref) {
  var title = _ref.title,
      customTitle = _ref.customTitle;
  return customTitle ? customTitle : /*#__PURE__*/_react["default"].createElement(_Title.Title, {
    headingLevel: "h1",
    size: "xl"
  }, title);
};

exports.RenderTitle = RenderTitle;
RenderTitle.propTypes = {
  title: _propTypes["default"].node,
  customTitle: _propTypes["default"].node
};

var DefaultStepTemplate = function DefaultStepTemplate(_ref2) {
  var formFields = _ref2.formFields,
      formRef = _ref2.formRef,
      title = _ref2.title,
      customTitle = _ref2.customTitle,
      showTitle = _ref2.showTitle,
      showTitles = _ref2.showTitles;
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: formRef,
    className: "pf-c-form"
  }, (showTitles && showTitle !== false || showTitle) && /*#__PURE__*/_react["default"].createElement(RenderTitle, {
    title: title,
    customTitle: customTitle
  }), formFields);
};

DefaultStepTemplate.propTypes = {
  title: _propTypes["default"].node,
  formFields: _propTypes["default"].array.isRequired,
  formOptions: _propTypes["default"].shape({
    renderForm: _propTypes["default"].func.isRequired
  }).isRequired,
  showTitles: _propTypes["default"].bool,
  showTitle: _propTypes["default"].bool,
  customTitle: _propTypes["default"].node,
  formRef: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].shape({
    current: _propTypes["default"].instanceOf(Element)
  })])
};

var WizardStep = function WizardStep(_ref3) {
  var name = _ref3.name,
      title = _ref3.title,
      description = _ref3.description,
      fields = _ref3.fields,
      formOptions = _ref3.formOptions,
      showTitles = _ref3.showTitles,
      showTitle = _ref3.showTitle,
      customTitle = _ref3.customTitle,
      hasNoBodyPadding = _ref3.hasNoBodyPadding,
      StepTemplate = _ref3.StepTemplate,
      rest = (0, _objectWithoutProperties2["default"])(_ref3, ["name", "title", "description", "fields", "formOptions", "showTitles", "showTitle", "customTitle", "hasNoBodyPadding", "StepTemplate"]);
  var formRef = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    // HACK: I can not pass ref to WizardBody because it is not
    // wrapped by forwardRef. However, the step body (the one that overflows)
    // is the grand parent of the form element.
    var stepBody = formRef.current && formRef.current.parentNode.parentNode;
    stepBody && stepBody.scrollTo({
      top: 0,
      left: 0,
      behavior: 'smooth'
    });
  }, [name]);
  return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_WizardBody.WizardBody, {
    hasNoBodyPadding: hasNoBodyPadding
  }, /*#__PURE__*/_react["default"].createElement(StepTemplate, (0, _extends2["default"])({
    formFields: fields.map(function (item) {
      return formOptions.renderForm([item], formOptions);
    }),
    name: name,
    title: title,
    description: description,
    formOptions: formOptions,
    showTitles: showTitles,
    showTitle: showTitle,
    customTitle: customTitle,
    hasNoBodyPadding: hasNoBodyPadding,
    formRef: formRef,
    fields: fields
  }, rest))), /*#__PURE__*/_react["default"].createElement(_stepButtons["default"], (0, _extends2["default"])({
    formOptions: formOptions
  }, rest)));
};

WizardStep.propTypes = {
  title: _propTypes["default"].node,
  description: _propTypes["default"].node,
  fields: _propTypes["default"].array.isRequired,
  formOptions: _propTypes["default"].shape({
    renderForm: _propTypes["default"].func.isRequired
  }).isRequired,
  showTitles: _propTypes["default"].bool,
  showTitle: _propTypes["default"].bool,
  customTitle: _propTypes["default"].node,
  name: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  hasNoBodyPadding: _propTypes["default"].bool,
  StepTemplate: _propTypes["default"].elementType
};
WizardStep.defaultProps = {
  StepTemplate: DefaultStepTemplate
};
var _default = WizardStep;
exports["default"] = _default;