"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _angleRightIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/angle-right-icon"));

var _caretDownIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/caret-down-icon"));

var WizardToggle = function WizardToggle(_ref) {
  var _navSchema$find, _navSchema$find2, _navSchema$find3;

  var activeStepIndex = _ref.activeStepIndex,
      currentStep = _ref.currentStep,
      navSchema = _ref.navSchema,
      isOpen = _ref.isOpen,
      dispatch = _ref.dispatch;
  var substepTitle = (_navSchema$find = navSchema.find(function (step) {
    return step.name === currentStep.name;
  })) === null || _navSchema$find === void 0 ? void 0 : _navSchema$find.substepOfTitle;
  var substepName = (_navSchema$find2 = navSchema.find(function (step) {
    return step.name === currentStep.name;
  })) === null || _navSchema$find2 === void 0 ? void 0 : _navSchema$find2.substepOf;
  var index = substepName ? (_navSchema$find3 = navSchema.find(function (step) {
    return step.substepOf === substepName;
  })) === null || _navSchema$find3 === void 0 ? void 0 : _navSchema$find3.index : activeStepIndex;
  var activeStepName = substepTitle || currentStep.title;
  var activeStepSubName = substepTitle ? currentStep.title : undefined;
  return /*#__PURE__*/_react["default"].createElement("button", {
    onClick: function onClick() {
      return dispatch({
        type: isOpen ? 'closeNav' : 'openNav'
      });
    },
    className: "pf-c-wizard__toggle ".concat(isOpen ? 'pf-m-expanded' : ''),
    "aria-label": "Wizard Toggle",
    "aria-expanded": isOpen,
    type: "button"
  }, /*#__PURE__*/_react["default"].createElement("ol", {
    className: "pf-c-wizard__toggle-list"
  }, /*#__PURE__*/_react["default"].createElement("li", {
    className: "pf-c-wizard__toggle-list-item"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "pf-c-wizard__toggle-num"
  }, index + 1), " ", activeStepName, activeStepSubName && /*#__PURE__*/_react["default"].createElement(_angleRightIcon["default"], {
    className: "pf-c-wizard__toggle-separator",
    "aria-hidden": "true"
  })), activeStepSubName && /*#__PURE__*/_react["default"].createElement("li", {
    className: "pf-c-wizard__toggle-list-item"
  }, activeStepSubName)), /*#__PURE__*/_react["default"].createElement("span", {
    className: "pf-c-wizard__toggle-icon"
  }, /*#__PURE__*/_react["default"].createElement(_caretDownIcon["default"], {
    "aria-hidden": "true"
  })));
};

WizardToggle.propTypes = {
  activeStepIndex: _propTypes["default"].number,
  currentStep: _propTypes["default"].object,
  navSchema: _propTypes["default"].array,
  isOpen: _propTypes["default"].bool,
  dispatch: _propTypes["default"].func
};
var _default = WizardToggle;
exports["default"] = _default;