"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formSpy = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/form-spy"));

var _wizardContext = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/wizard-context"));

var _wizard = _interopRequireDefault(require("@data-driven-forms/common/wizard/wizard"));

var _WizardNav = require("@patternfly/react-core/dist/js/components/Wizard/WizardNav.js");

var _WizardHeader = require("@patternfly/react-core/dist/js/components/Wizard/WizardHeader.js");

var _Modal = require("@patternfly/react-core/dist/js/components/Modal/Modal.js");

var _wizardStep = _interopRequireDefault(require("./wizard-components/wizard-step"));

require("./wizard-components/wizard-styles.css");

var _wizardNav = _interopRequireDefault(require("./wizard-components/wizard-nav"));

var _reducer = _interopRequireDefault(require("./wizard-components/reducer"));

var _wizardToggle = _interopRequireDefault(require("./wizard-components/wizard-toggle"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Modal = function Modal(_ref) {
  var children = _ref.children,
      container = _ref.container,
      inModal = _ref.inModal,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["children", "container", "inModal"]);
  return inModal ? /*#__PURE__*/_react["default"].createElement(_Modal.Modal, (0, _extends2["default"])({
    variant: "large",
    isOpen: true,
    showClose: false,
    hasNoBodyWrapper: true,
    appendTo: container
  }, rest), children) : children;
};

Modal.propTypes = {
  children: _propTypes["default"].node,
  container: _propTypes["default"].instanceOf(Element),
  inModal: _propTypes["default"].bool
};

var WizardInternal = function WizardInternal(_ref2) {
  var inModal = _ref2.inModal,
      title = _ref2.title,
      description = _ref2.description,
      buttonLabels = _ref2.buttonLabels,
      buttonsClassName = _ref2.buttonsClassName,
      showTitles = _ref2.showTitles,
      container = _ref2.container,
      hideClose = _ref2.hideClose,
      titleId = _ref2.titleId,
      descriptionId = _ref2.descriptionId,
      closeButtonAriaLabel = _ref2.closeButtonAriaLabel,
      hasNoBodyPadding = _ref2.hasNoBodyPadding,
      navAriaLabel = _ref2.navAriaLabel,
      StepTemplate = _ref2.StepTemplate,
      className = _ref2.className,
      rest = (0, _objectWithoutProperties2["default"])(_ref2, ["inModal", "title", "description", "buttonLabels", "buttonsClassName", "showTitles", "container", "hideClose", "titleId", "descriptionId", "closeButtonAriaLabel", "hasNoBodyPadding", "navAriaLabel", "StepTemplate", "className"]);

  var _useContext = (0, _react.useContext)(_wizardContext["default"]),
      crossroads = _useContext.crossroads,
      formOptions = _useContext.formOptions,
      currentStep = _useContext.currentStep,
      handlePrev = _useContext.handlePrev,
      _onKeyDown = _useContext.onKeyDown,
      _jumpToStep = _useContext.jumpToStep,
      setPrevSteps = _useContext.setPrevSteps,
      _handleNext = _useContext.handleNext,
      navSchema = _useContext.navSchema,
      activeStepIndex = _useContext.activeStepIndex,
      maxStepIndex = _useContext.maxStepIndex,
      isDynamic = _useContext.isDynamic;

  var _useReducer = (0, _react.useReducer)(_reducer["default"], {
    loading: true,
    container: container,
    openNav: false
  }),
      _useReducer2 = (0, _slicedToArray2["default"])(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  (0, _react.useEffect)(function () {
    if (inModal) {
      dispatch({
        type: 'setContainer'
      });
    } else {
      dispatch({
        type: 'finishLoading'
      });
    }
  }, [inModal]);
  (0, _react.useEffect)(function () {
    if (state.container) {
      document.body.appendChild(state.container);
      dispatch({
        type: 'finishLoading'
      });
    }

    return function () {
      if (inModal && state.container) {
        document.body.removeChild(state.container);
      }
    };
  }, [state.container, inModal]);

  if (state.loading) {
    return null;
  }

  return /*#__PURE__*/_react["default"].createElement(Modal, {
    inModal: inModal,
    container: state.container,
    "aria-labelledby": rest.name
  }, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: "pf-c-wizard ".concat(inModal ? '' : 'no-shadow', " ddorg__pf4-component-mapper__wizard ").concat(className ? className : ''),
    role: "dialog",
    "aria-modal": inModal ? 'true' : undefined,
    onKeyDown: function onKeyDown(e) {
      _onKeyDown(e);

      if (e.key === 'Escape' && inModal) {
        formOptions.onCancel();
      }
    }
  }, rest), title && /*#__PURE__*/_react["default"].createElement(_WizardHeader.WizardHeader, {
    title: title,
    description: description,
    onClose: formOptions.onCancel,
    hideClose: hideClose,
    titleId: titleId,
    descriptionId: descriptionId,
    closeButtonAriaLabel: closeButtonAriaLabel
  }), /*#__PURE__*/_react["default"].createElement(_wizardToggle["default"], {
    activeStepIndex: activeStepIndex,
    currentStep: currentStep,
    navSchema: navSchema,
    isOpen: state.openNav,
    dispatch: dispatch
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "pf-c-wizard__outer-wrap"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "pf-c-wizard__inner-wrap"
  }, /*#__PURE__*/_react["default"].createElement(_WizardNav.WizardNav, {
    "aria-label": navAriaLabel,
    isOpen: state.openNav
  }, /*#__PURE__*/_react["default"].createElement(_formSpy["default"], {
    subscription: {
      values: true,
      valid: true,
      validating: true
    }
  }, function (_ref3) {
    var values = _ref3.values,
        valid = _ref3.valid,
        validating = _ref3.validating;
    return /*#__PURE__*/_react["default"].createElement(_wizardNav["default"], {
      navSchema: navSchema,
      activeStepIndex: activeStepIndex,
      valid: valid,
      maxStepIndex: maxStepIndex,
      jumpToStep: function jumpToStep() {
        state.openNav && dispatch({
          type: 'closeNav'
        });
        return _jumpToStep.apply(void 0, arguments);
      },
      crossroads: crossroads,
      isDynamic: isDynamic,
      values: values,
      setPrevSteps: setPrevSteps,
      validating: validating
    });
  })), /*#__PURE__*/_react["default"].createElement(_wizardStep["default"], (0, _extends2["default"])({
    buttonLabels: buttonLabels,
    buttonsClassName: buttonsClassName,
    showTitles: showTitles,
    hasNoBodyPadding: hasNoBodyPadding,
    StepTemplate: StepTemplate
  }, currentStep, {
    formOptions: formOptions,
    handleNext: function handleNext(nextStep) {
      return _handleNext(nextStep);
    },
    handlePrev: handlePrev,
    disableBack: activeStepIndex === 0
  }))))));
};

WizardInternal.propTypes = {
  buttonLabels: _propTypes["default"].shape({
    submit: _propTypes["default"].node.isRequired,
    cancel: _propTypes["default"].node.isRequired,
    back: _propTypes["default"].node.isRequired,
    next: _propTypes["default"].node.isRequired
  }).isRequired,
  buttonsClassName: _propTypes["default"].string,
  title: _propTypes["default"].any,
  description: _propTypes["default"].any,
  inModal: _propTypes["default"].bool,
  showTitles: _propTypes["default"].bool,
  hideClose: _propTypes["default"].bool,
  titleId: _propTypes["default"].string,
  descriptionId: _propTypes["default"].string,
  closeButtonAriaLabel: _propTypes["default"].string,
  hasNoBodyPadding: _propTypes["default"].bool,
  navAriaLabel: _propTypes["default"].string,
  container: _propTypes["default"].instanceOf(Element),
  StepTemplate: _propTypes["default"].elementType,
  className: _propTypes["default"].string
};
var defaultLabels = {
  submit: 'Submit',
  cancel: 'Cancel',
  back: 'Back',
  next: 'Next'
};

var WizardFunction = function WizardFunction(_ref4) {
  var buttonLabels = _ref4.buttonLabels,
      props = (0, _objectWithoutProperties2["default"])(_ref4, ["buttonLabels"]);
  return /*#__PURE__*/_react["default"].createElement(_wizard["default"], (0, _extends2["default"])({
    Wizard: WizardInternal
  }, props, {
    buttonLabels: _objectSpread(_objectSpread({}, defaultLabels), buttonLabels)
  }));
};

WizardFunction.propTypes = {
  buttonLabels: _propTypes["default"].shape({
    submit: _propTypes["default"].node,
    cancel: _propTypes["default"].node,
    back: _propTypes["default"].node
  })
};
WizardFunction.defaultProps = {
  buttonLabels: {}
};
var _default = WizardFunction;
exports["default"] = _default;